<?php
require_once "config.php";
require_once "mainfile.php";

if (isset($_POST['do_update'])) {
	if (!empty($_POST['updatefiles']) && !empty($_POST['filename']) && !empty($_POST['gcfname']) ) {
		$_updatefiles = explode("\n", $_POST['updatefiles']);
		$filename = $_POST['filename'];
		$gcfname = $_POST['gcfname'];

		$new_ver = New GCFClass;
		$new_ver->Load(CACHES_FOLDER.$gcfname);

		$count = count($_updatefiles) - 1;
		$_blockcount = (int)($_updatefiles[$count]);
		$blockcount = 0;
		$updatefiles = array();

		for($i=0;$i < $count;$i++) {
			$dirid = (int)($_updatefiles[$i]);
			$dir_entry = $new_ver->manifest['dir_entries2'][$dirid];
			$blockcount += countblocks($dir_entry['itemsize']);
			$updatefiles[$dirid] = $dir_entry;
			unset($dir_entry);
		}

		if ($blockcount != $_blockcount) {
			exit;
		}
		unset($_updatefiles);
		unset($_blockcount);

		$firstblockoffset = 44;
		$firstblockoffset += 32;
		$firstblockoffset += (28 * $blockcount);
		$firstblockoffset += 16;
		$firstblockoffset += (4 * $blockcount);
		$firstblockoffset += ($new_ver->dirmap_index - $new_ver->manifest_index);
		$firstblockoffset += 8;
		$firstblockoffset += ($new_ver->manifest['num_items'] * 4);
		$firstblockoffset += 8;
		$firstblockoffset += $new_ver->checksumsize;
		$firstblockoffset += 24;

		$blocksused = count($updatefiles);

		$gcf_filesize = $firstblockoffset + ($blockcount * 8192);

		$gcf = New DATAClass;
		$gcf->open($filename, 0, $gcf_filesize);

		// Header

		$gcf_header = pack("L10", 1,1,6,$new_ver->appid,$new_ver->appversion,0,0,$gcf_filesize,8192,$blockcount);
		$gcf_header_checksum = pack("L1", calcbytes($gcf_header));

		$gcf->write($gcf_header.$gcf_header_checksum);

		// Blocks
		$block_index = 0;
		$dirmap_index = 0;
		$empty_block_entry = pack("L6", 0, 0, 0, 0, $blockcount, $blockcount)."\xFF\xFF\xFF\xFF";
		$gcf_block_header = pack("L7", $blockcount, $blocksused,($blocksused-1),0,0,0,0);
		$gcf_block_header_checksum = pack("L1", (($blocksused * 2) - 1) + $blockcount);

		$gcf->write($gcf_block_header.$gcf_block_header_checksum);

		foreach($updatefiles as $dirid => $dir_entry) {
			$nextblock = $new_ver->dirmap_entries[$dir_entry['i']];
			$b = $new_ver->block_entries[$nextblock];
			$block_bin = pack("L7", $b['entry_type'], 0, $dir_entry['itemsize'], $block_index, $blockcount, $blockcount, $dir_entry['i']);
			$gcf->write($block_bin);
			$updatefiles[$dirid]['dirmap_index'] = $dirmap_index;
			$updatefiles[$dirid]['file_index'] = ($block_index * 8192);
			$block_index += countblocks($dir_entry['itemsize']);
			$dirmap_index++;
			unset($nextblock);
			unset($b);
		}

		$count = ($blockcount - count($updatefiles));
		for($i=0;$i < $count;$i++) {
			$gcf->write($empty_block_entry);
		}

		// Frag map
		$gcf_frag_header = pack("L3", $blockcount, 0, 0);
		$gcf_frag_header_checksum = pack("L1", ($blockcount + 0 + 0));

		$gcf->write($gcf_frag_header.$gcf_frag_header_checksum);
		$i = 1;
		foreach($updatefiles as $dirid => $dir_entry) {
			$b = countblocks($dir_entry['itemsize']) - 1;
			while($b) {
				$gcf->write(pack("L1", $i));
				$b--;
				$i++;
			}
			//break;
			$gcf->write("\xFF\xFF\x00\x00");
			$i++;
		}

		// Manifest
		fseek($new_ver->f, $new_ver->manifest_index);
		$gcf_manifest_size = $new_ver->dirmap_index - $new_ver->manifest_index;
		$gcf_manifest_data = fread($new_ver->f, $gcf_manifest_size);

		$gcf->write($gcf_manifest_data);

		// DirMap
		$gcf_dirmap_header = "\x01\x00\x00\x00\x00\x00\x00\x00";

		$gcf->write($gcf_dirmap_header);
		for ($i=0;$i < $new_ver->manifest['num_items'];$i++) {
			$dir_entry = $new_ver->manifest['dir_entries1'][$i];
			if (empty($updatefiles[$dir_entry['fileid']])) {
				$gcf->write(pack("L1", $blockcount));
			} else {
				$gcf->write(pack("L1", $updatefiles[$dir_entry['fileid']]['dirmap_index']));
			}
		}

		// Checksums
		fseek($new_ver->f, $new_ver->checksum_index);
		$gcf_checksum_header = fread($new_ver->f, 8);
		$gcf_checksum_data = fread($new_ver->f, $new_ver->checksumsize);

		$gcf->write($gcf_checksum_header);
		$gcf->write($gcf_checksum_data);

		// Block Data Header
		$firstblockoffset = $gcf->tell() + 24;								         // $blocksused
		$gcf_block_data_header = pack("L5", $new_ver->appversion, $blockcount, 8192, $firstblockoffset, $blockcount);
		$gcf_block_data_header_checksum = pack("L1", $blockcount + 8192 + $firstblockoffset + $blockcount);
		$gcf->write($gcf_block_data_header.$gcf_block_data_header_checksum);

		$gcf_index = 0;
		foreach($updatefiles as $dirid => $dir_entry) {
			$nextblock = $new_ver->dirmap_entries[$dir_entry['i']];
			while (!connection_aborted() && $nextblock < $new_ver->blockcount) {
				$b = $new_ver->block_entries[$nextblock];
				$nextdata = $b['first_data_block_index'];
				$datasize = $b['file_data_size'];
				while(!connection_aborted() && true) {
					$index = $new_ver->firstblockoffset + ($nextdata * 8192);
					fseek($new_ver->f, $index);
					$nextdata = $new_ver->frag_entries[$nextdata];
					if ($nextdata < $new_ver->blockcount) {
						$gcf->write(fread($new_ver->f, 8192));
						$datasize -= 8192;
					} else {
						$gcf->write(fread($new_ver->f, $datasize));
						break 1;
					}
					if ($gcf->tell() > $gcf_filesize) exit;
				}
				$nextblock = $b['next_block_entry_index'];
			}
			if (connection_aborted()) {
				exit;
			}
			$blocksize = countblocks($dir_entry['itemsize']) * 8192;
			$gcf_index = $dir_entry['file_index'] + blocksize;
			if ($dir_entry['itemsize'] < $blocksize) {
				$empty_data = str_repeat("\x00", ($blocksize - $dir_entry['itemsize']));
				$gcf->write($empty_data);
			}
		}
		$gcf->close();
		$new_ver->close();
		exit;
	}
} else if (isset($_POST['do_upload'])) {
	$error = 0;
	$tmp = $HTTP_POST_FILES['archive']['tmp_name'];
	if (is_uploaded_file($tmp)) { $old = get_gcf_info($tmp); } else { $error = 1; }
	if (!is_array($old) && !$error) { $error = 2; }
	if (empty($storage[$old['appid']]) && !$error) { $error = 3; }
	$ver = $storage[$old['appid']]['appversion']; $path = $storage[$old['appid']]['path'];
	if ($ver < $old['appversion'] && !$error) { $error = 4; }
	if ($error == 0) {
		$update_info = compare_gcf($path, $tmp);
		unlink($tmp);
		require_once "header.php";
		open_table("Steam Content Online Updater");
		if (count($update_info['updatefiles']) != 0) {
			$updatefiles = "";
			foreach($update_info['updatefiles'] as $dirid => $dir_entry) { $updatefiles .= $dirid."\n"; }
			$updatefiles .= $update_info['blockcount'];
			$update_filename = substr($storage[$old['appid']]['filename'], 0, strpos($storage[$old['appid']]['filename'], "."));
			$update_filename .= ".".$old['appversion']."_to_".$ver.".update.gcf";
			echo "<form method='post' enctype='multipart/form-data' name='mainform' action='index.php/".$update_filename."'>\n";
			echo "<input type='hidden' name='updatefiles' value='$updatefiles'>";
			echo "<input type='hidden' name='filename' value='$update_filename'>";
			echo "<input type='hidden' name='gcfname' value='".$storage[$old['appid']]['filename']."'>";
			echo "<table width='500' cellspacing='0' cellpadding='1'>\n<tr>\n<td class='td' colspan='2'>\n";
			echo "<li>".$update_filename."</li>";
			echo "<li>Files to update: ".count($update_info['updatefiles'])."</li>";
			echo "<li>Update file size: ".parsesize($update_info['gcf_size'])."</li>";
			echo "</td>\n</tr>\n<tr>\n<td>\n";
			echo "<input type='button' name='do_cancel' value='Cancel' class='btn' onclick=\"javascript:document.location.href='index.php'\">\n";
			echo "</td>\n<td align='right'>\n";
			echo "<input type='submit' name='do_update' value='Download Update' class='btn'>\n";
			echo "</td>\n</tr>\n</table>\n";
			echo "</form>\n";
		} else {
			echo "<table width='500' cellspacing='0' cellpadding='1'>\n<tr>\n<td class='td'>\n";
			echo "<li>Update no needed.</li>";
			echo "</td>\n</tr>\n<tr>\n<td align='right'>\n";
			echo "<input type='button' name='do_ok' value=' OK ' class='btn' onclick=\"javascript:document.location.href='index.php'\">\n";
			echo "</td>\n</tr>\n</table>\n";
		}
		close_table();
		require_once "footer.php";
	} else {
		echo $errors[$error];
	}
} else {
	require_once "header.php";
	open_table("Steam Content Online Updater");
	echo "<table width='500' cellspacing='0' cellpadding='1'>\n<tr>\n<td class='td'>\n";
	echo $info_text."\n";
	echo "</td>\n</tr>\n<tr>\n<td>";
	echo "<form method='post' enctype='multipart/form-data' name='mainform' action='index.php'>\n";
	echo "<input type='file' name='archive' style='width:368px;'>\n";
	echo "<input type='submit' name='do_upload' value='Upload .archive' class='btn'>\n";
	echo "</form>\n";
	echo "</td>\n</tr>\n</table>\n";
	close_table();
	
	open_table("Available Content");
	echo "<table width='100%' cellspacing='0' cellpadding='1' height='8'>\n";
	echo "<tr class='panel-buttom'>\n";
	echo "<td width='1'>&nbsp;</td>\n";
	echo "<td>File Name</td>\n";
	echo "<td width='25' align='center'>ver</td>\n";
	echo "<td width='100' align='center'>Size</td>\n";
	echo "</tr>\n";
	foreach($storage as $app_id => $info) {
		echo "<tr>\n";
		echo "<td class='td' width='1'><img src='images/gcf_icon.png'></td>\n";
		echo "<td class='td'>&nbsp;<a href='".CACHES_FOLDER.$info['filename']."'>".$info['filename']."</a></td>\n";
		echo "<td class='td' width='1' align='center'>&nbsp;".$info['appversion']."</td>\n";
		echo "<td class='td' align='center'>&nbsp;".parsesize($info['filesize'])."</td>\n";
		echo "</tr>\n";
	}
	echo "</table>\n";
	close_table();
	require_once "footer.php";
}
?>